diff -ruN ../nakedmudv2.2/src/interpret.c src/interpret.c
--- ../nakedmudv2.2/src/interpret.c	Thu May 12 17:08:52 2005
+++ src/interpret.c	Fri May 27 01:30:58 2005
@@ -38,15 +38,15 @@
 LIST   **cmd_table = NULL;
 
 typedef struct cmd_data {
-  char      * cmd_name;
-  char      * sort_by;
+  char *cmd_name;
+  char *sort_by;
   CMD_PTR(cmd_funct);
-  int        subcmd;
-  int        min_pos;
-  int        max_pos;
-  int        level;
-  bool       mob_ok;     // can NPCs use this command?
-  bool       interrupts; // does it interrupt actions?
+  int   subcmd;
+  int   min_pos;
+  int   max_pos;
+  char *user_group;
+  bool  mob_ok;     // can NPCs use this command?
+  bool  interrupts; // does it interrupt actions?
 } CMD_DATA;
 
 
@@ -56,226 +56,220 @@
   for(i = 0; i < 26; i++)
     cmd_table[i] = newList();
 
-  //************************************************************************
+  //***************************************************************************
   // This is for core functions ONLY! If you have a module that adds new
   // functions to the MUD, they should be added in the init_xxx() function
   // associated with your module.
-  //************************************************************************
+  //***************************************************************************
   add_cmd("north", "n", cmd_move,     DIR_NORTH,    POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("east",  "e", cmd_move,     DIR_EAST,     POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("south", "s", cmd_move,     DIR_SOUTH,    POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("west",  "w", cmd_move,     DIR_WEST,     POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("up",    "u", cmd_move,     DIR_UP,       POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("down",  "d", cmd_move,     DIR_DOWN,     POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("northeast", "na", cmd_move,DIR_NORTHEAST,POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("southeast", "sa",  cmd_move,DIR_SOUTHEAST,POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("southwest", "sb", cmd_move,DIR_SOUTHWEST,POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("northwest", "nb", cmd_move,DIR_NORTHWEST,POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("ne",        "ne", cmd_move,DIR_NORTHEAST,POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("se",        "se", cmd_move,DIR_SOUTHEAST,POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("sw",        "sw", cmd_move,DIR_SOUTHWEST,POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("nw",        "nw", cmd_move,DIR_NORTHWEST,POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
 
   // A
   add_cmd("approach",   NULL, cmd_greet,    0, POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("ask",        NULL, cmd_ask,      0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("at",         NULL, cmd_at,       0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, TRUE, FALSE);
+	  "builder", TRUE, FALSE);
 
   // B
   add_cmd("back",       NULL, cmd_back,     0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("buildwalk",  NULL, cmd_buildwalk, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
 
   // C
   add_cmd("chat",       NULL, cmd_chat,     0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("clear",      NULL, cmd_clear,    0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("close",      NULL, cmd_close,    0, POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("commands",   NULL, cmd_commands, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("compress",   NULL, cmd_compress, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER, FALSE, FALSE);
+	  "player", FALSE, FALSE);
   add_cmd("copyover",   NULL, cmd_copyover, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_ADMIN,  FALSE, TRUE);
+	  "admin",  FALSE, TRUE);
 
   // D
   add_cmd("delay",      NULL, cmd_delay,    0, POS_SLEEPING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE,  FALSE);
+	  "player", TRUE,  FALSE);
   add_cmd("dig",        NULL, cmd_dig,      0, POS_STANDING, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   add_cmd("dlist",      NULL, cmd_dlist,    0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   add_cmd("ddelete",    NULL, cmd_ddelete,  0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   add_cmd("drop",       NULL, cmd_drop,     0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
 
   // E
   add_cmd("emote",      NULL, cmd_emote,    0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd(":",          NULL, cmd_emote,    0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("equipment",  NULL, cmd_equipment,0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
 
   // F
   add_cmd("fill",       NULL, cmd_fill,     0, POS_STANDING, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, TRUE );
+	  "builder", FALSE, TRUE );
 
   // G
   add_cmd("gemote",     NULL, cmd_gemote,   0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("give",       NULL, cmd_give,     0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("gossip",     NULL, cmd_chat,     0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("\"",         NULL, cmd_chat,     0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("greet",      NULL, cmd_greet,    0, POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("get",        NULL, cmd_get,      0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("goto",       NULL, cmd_goto,     0, POS_STANDING, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, TRUE );
+	  "builder", FALSE, TRUE );
+  add_cmd("groupcmds",  NULL, cmd_groupcmds,0, POS_UNCONCIOUS, POS_FLYING,
+	  "player", FALSE, FALSE);
 
   // I
   add_cmd("inventory",  NULL, cmd_inventory,0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
-  add_cmd("invis",      NULL, cmd_invis,    0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "player", TRUE, FALSE);
 
   // L
   add_cmd("look",       "l",  cmd_look,     0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("lock",       NULL,  cmd_lock,    0, POS_STANDING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE);
+	  "player", TRUE, TRUE);
   add_cmd("land",       NULL, cmd_stand,    0, POS_FLYING,   POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("load",       NULL, cmd_load,     0, POS_SITTING,  POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   add_cmd("linkdead",   NULL, cmd_linkdead, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_ADMIN, FALSE, FALSE);
+	  "admin", FALSE, FALSE);
   add_cmd("lockdown",   NULL, cmd_lockdown, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_ADMIN, FALSE, FALSE);
+	  "admin", FALSE, FALSE);
 
   // M
   add_cmd("mlist",      NULL, cmd_mlist,    0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   add_cmd("mdelete",    NULL, cmd_mdelete,  0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   add_cmd("more",       NULL, cmd_more,     0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("motd",       NULL, cmd_motd,     0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
 
   // O
   add_cmd("olist",      NULL, cmd_olist,    0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   add_cmd("odelete",    NULL, cmd_odelete,  0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   add_cmd("open",       NULL, cmd_open,     0, POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
 
   // P
   add_cmd("put",        "p", cmd_put,       0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE,  TRUE );
+	  "player", TRUE,  TRUE );
   add_cmd("page",       NULL, cmd_page,     0, POS_SITTING,  POS_FLYING,
-	  LEVEL_BUILDER, TRUE, FALSE);
+	  "builder", TRUE, FALSE);
   add_cmd("purge",      NULL, cmd_purge,    0, POS_SITTING,  POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   
   // Q
   add_cmd("quit",       NULL, cmd_quit,     0, POS_SLEEPING, POS_FLYING,
-	  LEVEL_PLAYER, FALSE, TRUE );
+	  "player", FALSE, TRUE );
 
   // R
   add_cmd("remove",     NULL, cmd_remove,   0, POS_SITTING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("rlist",      NULL, cmd_rlist,    0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   add_cmd("rdelete",    NULL, cmd_rdelete,  0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
   add_cmd("repeat",     NULL, cmd_repeat,   0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_ADMIN, FALSE, FALSE);
+	  "admin", FALSE, FALSE);
 
   // S
   add_cmd("say",        NULL, cmd_say,      0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("'",          NULL, cmd_say,      0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("save",       NULL, cmd_save,     0, POS_SLEEPING, POS_FLYING,
-	  LEVEL_PLAYER, FALSE, FALSE);
+	  "player", FALSE, FALSE);
   add_cmd("shutdown",   NULL, cmd_shutdown, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_ADMIN, FALSE, TRUE );
+	  "admin", FALSE, TRUE );
   add_cmd("sit",        NULL, cmd_sit,      0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("sleep",      NULL, cmd_sleep,    0, POS_SITTING,  POS_STANDING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("stand",      NULL, cmd_stand,    0, POS_SITTING,  POS_STANDING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("stop",       NULL, cmd_stop,     0, POS_SITTING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   // really, we -should- put this in the scripts module, but there are some
   // very nice functions in builder.c that cmd_sclist uses to print scripts,
   // which wouldn't be accessable from outside of builder.c
   add_cmd("sclist",     NULL, cmd_sclist,   0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
-  add_cmd("sdelete",    NULL, cmd_scdelete, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
+  add_cmd("scdelete",    NULL, cmd_scdelete, 0, POS_UNCONCIOUS, POS_FLYING,
+	  "builder", FALSE, FALSE);
 
   // T
   add_cmd("take",       NULL, cmd_get,      0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("tell",       NULL, cmd_tell,     0, POS_SLEEPING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("transfer",   NULL, cmd_transfer, 0, POS_STANDING, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, TRUE);
+	  "builder", FALSE, TRUE);
 
   // U
   add_cmd("unlock",       NULL,  cmd_unlock,    0, POS_STANDING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE);
-
-  // V
-  add_cmd("visible",      NULL, cmd_visible,    0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "player", TRUE, TRUE);
 
   // W
   add_cmd("wake",       NULL, cmd_wake,     0, POS_SLEEPING,  POS_SLEEPING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("wear",       NULL, cmd_wear,     0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE );
+	  "player", TRUE, TRUE );
   add_cmd("who",        NULL, cmd_who,      0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
-  add_cmd("wizhelp",    NULL, cmd_wizhelp,  0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "player", TRUE, FALSE);
   add_cmd("worn",       NULL, cmd_equipment,0, POS_SITTING,  POS_FLYING,
-	  LEVEL_PLAYER, TRUE, FALSE);
+	  "player", TRUE, FALSE);
 
   // Z
   add_cmd("zlist",      NULL, cmd_zlist,    0, POS_SITTING,  POS_FLYING,
-	  LEVEL_BUILDER, FALSE, TRUE);
+	  "builder", FALSE, TRUE);
   add_cmd("zreset",     NULL, cmd_zreset,   0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_BUILDER, FALSE, FALSE);
+	  "builder", FALSE, FALSE);
 }
 
 
@@ -326,15 +320,16 @@
 void remove_cmd(const char *cmd) {
   CMD_DATA *removed = listRemoveWith(cmd_table[cmdbucket(cmd)], cmd, is_cmd);
   if(removed) {
-    if(removed->cmd_name) free(removed->cmd_name);
-    if(removed->sort_by)  free(removed->sort_by);
+    if(removed->cmd_name)   free(removed->cmd_name);
+    if(removed->sort_by)    free(removed->sort_by);
+    if(removed->user_group) free(removed->user_group);
     free(removed);
   }
 }
 
 void add_cmd(const char *cmd, const char *sort_by,
 	     void *func, int subcmd, int min_pos, int max_pos,
-	     int min_level, bool mob_ok, bool interrupts) {
+	     const char *user_group, bool mob_ok, bool interrupts) {
   // if we've already got a command named this, remove it
   remove_cmd(cmd);
 
@@ -346,7 +341,7 @@
   new_cmd->subcmd     = subcmd;
   new_cmd->min_pos    = min_pos;
   new_cmd->max_pos    = max_pos;
-  new_cmd->level      = min_level;
+  new_cmd->user_group = strdup(user_group);
   new_cmd->mob_ok     = mob_ok;
   new_cmd->interrupts = interrupts;
 
@@ -355,8 +350,8 @@
 }
 
 
-// show the character all of the commands he or she can perform
-void show_commands(CHAR_DATA *ch, int min_lev, int max_lev) {
+// show the character all of the commands in the specified group(s).
+void show_commands(CHAR_DATA *ch, const char *user_groups) {
   BUFFER *buf = newBuffer(MAX_BUFFER);
   int i, col = 0;
 
@@ -366,7 +361,7 @@
     CMD_DATA *cmd = NULL;
 
     ITERATE_LIST(cmd, buck_i) {
-      if(min_lev > cmd->level || max_lev < cmd->level)
+      if(!is_keyword(user_groups, cmd->user_group, FALSE))
 	continue;
       bprintf(buf, "%-20.20s", cmd->cmd_name);
       if (!(++col % 4))
@@ -505,13 +500,16 @@
   if(scripts_ok && try_command_script(ch, command, arg))
     return;
 
+  // get the groups we belong to for seeing if we can use the command
+  const char *user_groups = bitvectorGetBits(charGetUserGroups(ch));
 
   // iterate over the commands that would be in our 
   // bucket and find the one that we are trying to use
   LIST_ITERATOR *cmd_i = newListIterator(cmd_table[cmdbucket(command)]);
   CMD_DATA *cmd = NULL;
   ITERATE_LIST(cmd, cmd_i) {
-    if (cmd->level > charGetLevel(ch))
+    // no group means anyone can do it
+    if(!is_keyword(user_groups, cmd->user_group, FALSE))
       continue;
 
     if (is_prefix(command, cmd->cmd_name)) {
diff -ruN ../nakedmudv2.2/src/items/portal.c src/items/portal.c
--- ../nakedmudv2.2/src/items/portal.c	Thu May 12 17:08:51 2005
+++ src/items/portal.c	Fri May 27 01:30:57 2005
@@ -191,5 +191,5 @@
 	       iedit_portal_parser);
 
   add_cmd("enter", NULL, cmd_enter, 0, POS_STANDING, POS_FLYING,
-	  LEVEL_PLAYER, TRUE, TRUE);
+	  "player", TRUE, TRUE);
 }
diff -ruN ../nakedmudv2.2/src/log.c src/log.c
--- ../nakedmudv2.2/src/log.c	Thu May 12 17:08:52 2005
+++ src/log.c	Fri May 27 01:30:58 2005
@@ -99,7 +99,7 @@
   }
 
   add_cmd("log", NULL, cmd_log, 0, POS_UNCONCIOUS, POS_FLYING,
-	  LEVEL_ADMIN, FALSE, FALSE);
+	  "admin", FALSE, FALSE);
 }
 
 
diff -ruN ../nakedmudv2.2/src/movement.c src/movement.c
--- ../nakedmudv2.2/src/movement.c	Thu May 12 17:08:52 2005
+++ src/movement.c	Fri May 27 01:30:58 2005
@@ -121,7 +121,7 @@
     if(bitIsOneSet(charGetPrfs(ch), "buildwalk"))
       return try_buildwalk(ch, dir);
     else
-      send_to_char(ch, "Alas, there is no exit in that direction.\r\n");
+      send_to_char(ch, "{gAlas, there is no exit in that direction.\r\n");
     return FALSE;
   }
 
diff -ruN ../nakedmudv2.2/src/mud.h src/mud.h
--- ../nakedmudv2.2/src/mud.h	Thu May 12 17:17:41 2005
+++ src/mud.h	Fri May 27 01:33:10 2005
@@ -133,14 +133,6 @@
 #define TSTATE_WAIT            2  /* Closed while in thread.         */
 #define TSTATE_CLOSED          3  /* Closed, ready to be recycled.   */
 
-/* player levels */
-#define LEVEL_PLAYER           1           // All of the normal players
-#define LEVEL_GOD              2           // All the people who run the show
-#define LEVEL_BUILDER          LEVEL_GOD   // Players who have building rights
-#define LEVEL_SCRIPTER         3           // Builders who have scripting rights
-#define LEVEL_ADMIN            4           // The people who oversee the MUD
-#define MAX_LEVEL              LEVEL_ADMIN
-
 /* Communication Ranges */
 #define COMM_LOCAL             0  /* same room only                  */
 #define COMM_GLOBAL            1  /* all over the game               */
@@ -172,11 +164,11 @@
 #define COMMAND(name)      void name(CHAR_DATA *ch, const char *cmd, \
 				     int subcmd, char *arg)
 void init_commands();
-void show_commands(CHAR_DATA *ch, int min_lev, int max_lev);
+void show_commands(CHAR_DATA *ch, const char *user_groups);
 void remove_cmd   (const char *cmd);
 void add_cmd      (const char *cmd, const char *sort_by, void *func, 
 	           int subcmd, int min_pos, int max_pos,
-	           int min_level, bool mob_ok, bool interrupts);
+	           const char *user_group, bool mob_ok, bool interrupts);
 bool cmd_exists   (const char *cmd);
 
 
diff -ruN ../nakedmudv2.2/src/scripts/module.mk src/scripts/module.mk
--- ../nakedmudv2.2/src/scripts/module.mk	Thu May 12 17:13:57 2005
+++ src/scripts/module.mk	Fri May 27 01:49:59 2005
@@ -104,13 +104,13 @@
 # Object files we generate
 SRC      += scripts/script_set.c scripts/script.c scripts/pychar.c \
 	    scripts/pyobj.c scripts/pymud.c scripts/pyroom.c \
-	    scripts/script_editor.c scripts/script_edit.c
+	    scripts/script_editor.c scripts/script_edit.c scripts/pyplugs.c
 
-# the top level directory of python
+# the top level directory of python.
 PYTHONTOP = /usr/local/include
 
 # the folder where python headers are located
 C_FLAGS  += -I$(PYTHONTOP)/python2.4
 
-# libraries we have to include
+# libraries we have to include.
 LIBS     += -Xlinker -export-dynamic -lm -ldl -lutil -L/usr/local/lib/python2.4/config -lpython2.4
